﻿Imports System.IO

Public Class frmDependendCombos

   Private _SourceSource As String() = "<Kein> Inp1 Inp2 Inp3 Inp4 Inp5 Inp6".Split
   Private _Sources(_SourceSource.Length - 2) As List(Of String)
   Private _Combos As ComboBox()
   Private _Handler As EventHandler = Sub(s, e) AssignSources()

   Public Sub New()
      InitializeComponent()
      _Combos = {ComboBox1, ComboBox2, ComboBox3, ComboBox4, ComboBox5, ComboBox6}
      For i = 0 To _Combos.Length - 1
         _Sources(i) = New List(Of String)(_SourceSource)
         _Combos(i).DataSource = _Sources(i)
      Next
      EnableEvent(True)
   End Sub

   Private Sub AssignSources()
      EnableEvent(False)
      For i = 0 To _Combos.Length - 1
         With _Sources(i)
            Dim selected = .Item(_Combos(i).SelectedIndex)
            .Clear()
            .AddRange(_SourceSource)
            .Add(selected)
         End With
      Next
      For Each src0 In _Sources
         For Each src In _Sources
            If src Is src0 Then Continue For
            Dim selected = src.Last
            If selected <> _SourceSource(0) Then src0.Remove(selected)
         Next
      Next
      For i = 0 To _Combos.Length - 1
         Dim src = _Sources(i)
         Dim selected = src.Last
         src.RemoveAt(src.Count - 1)
         _Combos(i).DataSource = Nothing
         _Combos(i).DataSource = src
         _Combos(i).SelectedIndex = src.IndexOf(selected)
      Next
      EnableEvent(True)
   End Sub

   Private Sub EnableEvent(value As Boolean)
      If value Then
         For Each cmb In _Combos
            AddHandler cmb.SelectedIndexChanged, _Handler
         Next
      Else
         For Each cmb In _Combos
            RemoveHandler cmb.SelectedIndexChanged, _Handler
         Next
      End If
   End Sub

End Class